"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CustomNodes = exports.Preview = void 0;
const react_1 = __importStar(require("react"));
const tree_layer_1 = require("./tree-layer");
const tree_node_context_1 = require("./tree-node-context");
const base_ui_graph_tree_indent_1 = require("@teambit/base-ui.graph.tree.indent");
const tree = [
    {
        id: 'folder',
        children: [
            { id: 'item' },
            { id: 'item2' },
            { id: 'sub-folder', children: [{ id: 'nested-item' }] },
        ],
    },
];
const Preview = () => {
    return (react_1.default.createElement("div", null,
        react_1.default.createElement(tree_layer_1.TreeLayer, { childNodes: tree, depth: 0 })));
};
exports.Preview = Preview;
const CustomNodes = () => {
    return (react_1.default.createElement(tree_node_context_1.TreeNodeContext.Provider, { value: CustomRenderer },
        react_1.default.createElement(tree_layer_1.TreeLayer, { childNodes: tree, depth: 0 })));
};
exports.CustomNodes = CustomNodes;
const CustomRenderer = ({ node, depth }) => {
    const { id, children } = node;
    const [isOpen, setOpen] = (0, react_1.useState)(true);
    if (!children) {
        return (react_1.default.createElement("div", { className: base_ui_graph_tree_indent_1.indentClass },
            "\u2618\uFE0F (",
            depth,
            ") ",
            id));
    }
    return (react_1.default.createElement("div", null,
        react_1.default.createElement("div", { onClick: (e) => {
                e.stopPropagation();
                setOpen((x) => !x);
            }, className: base_ui_graph_tree_indent_1.indentClass },
            isOpen ? '📂' : '📁',
            " (",
            depth,
            ") ",
            id),
        react_1.default.createElement("div", { style: (0, base_ui_graph_tree_indent_1.indentStyle)(depth) }, isOpen && react_1.default.createElement(tree_layer_1.TreeLayer, { childNodes: children, depth: depth }))));
};
//# sourceMappingURL=recursive-tree.composition.js.map